curl --request PUT \
--url https://iam.basaltic.sh/v1/service-accounts/{service_account_id}/inline-policies/{policy_name} \
--header 'Authorization: Bearer <token>' \
--header 'Content-Type: application/json' \
--data '
{
"document": {
"version": "2024-01-01",
"statements": [
{
"effect": "allow",
"actions": [
"s3:GetObject",
"s3:ListBucket"
],
"resources": [
"my-bucket/*",
"my-bucket"
],
"sid": "AllowS3Read",
"not_actions": [
"iam:*"
],
"not_resources": [
"crn:iam::production:role/*"
],
"conditions": [
{
"operator": "equals",
"key": "s3:prefix",
"values": [
"home/",
"shared/"
]
}
]
}
]
}
}
'import requests
url = "https://iam.basaltic.sh/v1/service-accounts/{service_account_id}/inline-policies/{policy_name}"
payload = { "document": {
"version": "2024-01-01",
"statements": [
{
"effect": "allow",
"actions": ["s3:GetObject", "s3:ListBucket"],
"resources": ["my-bucket/*", "my-bucket"],
"sid": "AllowS3Read",
"not_actions": ["iam:*"],
"not_resources": ["crn:iam::production:role/*"],
"conditions": [
{
"operator": "equals",
"key": "s3:prefix",
"values": ["home/", "shared/"]
}
]
}
]
} }
headers = {
"Authorization": "Bearer <token>",
"Content-Type": "application/json"
}
response = requests.put(url, json=payload, headers=headers)
print(response.text)const options = {
method: 'PUT',
headers: {Authorization: 'Bearer <token>', 'Content-Type': 'application/json'},
body: JSON.stringify({
document: {
version: '2024-01-01',
statements: [
{
effect: 'allow',
actions: ['s3:GetObject', 's3:ListBucket'],
resources: ['my-bucket/*', 'my-bucket'],
sid: 'AllowS3Read',
not_actions: ['iam:*'],
not_resources: ['crn:iam::production:role/*'],
conditions: [{operator: 'equals', key: 's3:prefix', values: ['home/', 'shared/']}]
}
]
}
})
};
fetch('https://iam.basaltic.sh/v1/service-accounts/{service_account_id}/inline-policies/{policy_name}', options)
.then(res => res.json())
.then(res => console.log(res))
.catch(err => console.error(err));
{
"inline_policy": {
"crn": "crn:iam::production:role/deployer/inline-policy/read-storage",
"id": "d4e5f6a7-b8c9-0123-4567-890abcdef123",
"principal_id": "550e8400-e29b-41d4-a716-446655440000",
"principal_type": "role",
"name": "S3BucketAccess",
"document": {
"version": "2024-01-01",
"statements": [
{
"effect": "allow",
"actions": [
"s3:GetObject",
"s3:ListBucket"
],
"resources": [
"my-bucket/*",
"my-bucket"
],
"sid": "AllowS3Read",
"not_actions": [
"iam:*"
],
"not_resources": [
"crn:iam::production:role/*"
],
"conditions": [
{
"operator": "equals",
"key": "s3:prefix",
"values": [
"home/",
"shared/"
]
}
]
}
]
},
"created_at": "2026-01-15T09:30:00Z",
"updated_at": "2026-01-16T14:20:00Z"
}
}{
"error": {
"code": "INVALID_INPUT",
"message": "Invalid request parameters",
"request_id": "550e8400-e29b-41d4-a716-446655440000"
}
}{
"error": {
"code": "UNAUTHORIZED",
"message": "Authentication required",
"request_id": "550e8400-e29b-41d4-a716-446655440000"
}
}{
"error": {
"code": "ACCESS_DENIED",
"message": "You don't have permission to perform this action",
"request_id": "550e8400-e29b-41d4-a716-446655440000"
}
}{
"error": {
"code": "NOT_FOUND",
"message": "Resource not found",
"request_id": "550e8400-e29b-41d4-a716-446655440000"
}
}{
"error": {
"code": "INTERNAL_ERROR",
"message": "An internal error occurred",
"request_id": "550e8400-e29b-41d4-a716-446655440000"
}
}Crear o reemplazar la directiva en línea de una cuenta de servicio
iam:PutInlinePolicy. Consulte permisos de IAM para obtener la lista completa, lo que cubre cada una y un ejemplo de directiva.Autorizaciones
Un token bearer de OAuth 2.0, enviado como Authorization: Bearer <token>. Esta es la forma recomendada de autenticación.
Obtén el token intercambiando el par de claves de acceso de una cuenta de servicio en POST /v1/oauth/token con grant_type=client_credentials. Es el flujo estándar de credenciales de cliente; las bibliotecas compatibles con OAuth pueden obtener y renovar el token por ti.
curl -s -u "$KEY_ID:$SECRET" -d grant_type=client_credentials \
https://iam.basaltic.sh/v1/oauth/token
Los tokens duran una hora por defecto. El mismo par de claves de acceso también sirve como credencial AWS SigV4 para el endpoint de objetos compatible con S3, que solo acepta ese método de autenticación.
Parámetros de ruta
"550e8400-e29b-41d4-a716-446655440000"
Nombre de la política en línea. Las ortografías de UUID y el prefijo literal crn: están reservados y no se pueden usar al crear una directiva.
"S3BucketAccess"
Cuerpo
Documento de política de estilo IAM
Show child attributes
Show child attributes
Respuesta
Política en línea almacenada
Show child attributes
Show child attributes

